]> git.ipfire.org Git - people/teissler/ipfire-2.x.git/blame - make.sh
Ein kleiner Fix fuer das VideoLan-Paket.
[people/teissler/ipfire-2.x.git] / make.sh
CommitLineData
df5e82b3 1#!/bin/bash
df5e82b3
MT
2############################################################################
3# #
f8e5510c 4# This file is part of the IPFire Firewall. #
df5e82b3 5# #
f8e5510c 6# IPFire is free software; you can redistribute it and/or modify #
df5e82b3
MT
7# it under the terms of the GNU General Public License as published by #
8# the Free Software Foundation; either version 2 of the License, or #
9# (at your option) any later version. #
10# #
f8e5510c 11# IPFire is distributed in the hope that it will be useful, #
df5e82b3
MT
12# but WITHOUT ANY WARRANTY; without even the implied warranty of #
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14# GNU General Public License for more details. #
15# #
16# You should have received a copy of the GNU General Public License #
f8e5510c 17# along with IPFire; if not, write to the Free Software #
df5e82b3
MT
18# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19# #
06209efc 20# Copyright (C) 2007 IPFire-Team <info@ipfire.org>. #
df5e82b3
MT
21# #
22############################################################################
df5e82b3
MT
23#
24
06209efc
MT
25NAME="IPFire" # Software name
26SNAME="ipfire" # Short name
905fbf3e 27VERSION="2.0beta1" # Version number
06209efc
MT
28SLOGAN="www.ipfire.org" # Software slogan
29CONFIG_ROOT=/var/ipfire # Configuration rootdir
30NICE=10 # Nice level
31MAX_RETRIES=1 # prefetch/check loop
15679d9f
MT
32KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
33MACHINE=`uname -m`
34SVN_REVISION=`svn info | grep Revision | cut -c 11-`
35
8f7b33ea 36IPFVER="full" # Which versions should be compiled? (full|devel)
03ad5f93
MT
37
38# Set an information about the build number
15679d9f
MT
39if [ -e ./.svn ]; then
40 FIREBUILD=`cat .svn/entries |sed -n 's/^[ \t]*revision=\"// p' | sed -n 's/\".*$// p'`
41fi
42
43# Debian specific settings
44if [ ! -e /etc/debian_version ]; then
df5e82b3 45 FULLPATH=`which $0`
15679d9f 46else
df5e82b3
MT
47 if [ -x /usr/bin/realpath ]; then
48 FULLPATH=`/usr/bin/realpath $0`
49 else
50 echo "ERROR: Need to do apt-get install realpath"
51 exit 1
52 fi
15679d9f 53fi
df5e82b3 54
15679d9f
MT
55PWD=`pwd`
56BASENAME=`basename $0`
57BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
58LOGFILE=$BASEDIR/log/_build.preparation.log
59export BASEDIR LOGFILE
60DIR_CHK=$BASEDIR/cache/check
61mkdir $BASEDIR/log/ 2>/dev/null
df5e82b3 62
15679d9f
MT
63# Include funtions
64. tools/make-functions
df5e82b3 65
15679d9f
MT
66if [ -f .config ]; then
67 . .config
68else
6b8cff41
MT
69 echo -e "${BOLD}No configuration found!${NORMAL}"
70 echo -ne "Do you want to create one (y/N)?"
71 read CREATE_CONFIG
72 echo ""
73 if [ "$CREATE_CONFIG" == "y" ]; then
74 make_config
75 fi
15679d9f 76fi
df5e82b3
MT
77
78prepareenv() {
79 ############################################################################
80 # #
81 # Are we running the right shell? #
82 # #
83 ############################################################################
84 if [ ! "$BASH" ]; then
1b273e8f 85 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
df5e82b3
MT
86 fi
87
88 if [ -z "${BASH_VERSION}" ]; then
1b273e8f 89 exiterror "Not running BASH shell."
df5e82b3
MT
90 fi
91
92
93 ############################################################################
94 # #
95 # Trap on emergency exit #
96 # #
97 ############################################################################
98 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
99
100
101 ############################################################################
102 # #
103 # Resetting our nice level #
104 # #
105 ############################################################################
9b0ff0a0 106 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
df5e82b3
MT
107 renice $NICE $$ > /dev/null
108 if [ `nice` != "$NICE" ]; then
1b273e8f
MT
109 beautify message FAIL
110 exiterror "Failed to set correct nice level"
15679d9f 111 else
1b273e8f 112 beautify message DONE
df5e82b3
MT
113 fi
114
15679d9f 115
df5e82b3
MT
116 ############################################################################
117 # #
118 # Checking if running as root user #
119 # #
120 ############################################################################
9b0ff0a0 121 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
df5e82b3 122 if [ `id -u` != 0 ]; then
1b273e8f
MT
123 beautify message FAIL
124 exiterror "Not building as root"
15679d9f 125 else
1b273e8f 126 beautify message DONE
df5e82b3
MT
127 fi
128
129
130 ############################################################################
131 # #
132 # Checking for necessary temporary space #
133 # #
134 ############################################################################
9b0ff0a0 135 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
df5e82b3
MT
136 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
137 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
41921bd9 138 if (( 2048000 > $BASE_ASPACE )); then
1b273e8f
MT
139 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
140 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
141 beautify message FAIL
142 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
143 fi
15679d9f 144 else
1b273e8f 145 beautify message DONE
df5e82b3
MT
146 fi
147
148 ############################################################################
149 # #
150 # Building Linux From Scratch system #
151 # #
152 ############################################################################
df5e82b3
MT
153 # Set umask
154 umask 022
155
156 # Set LFS Directory
157 LFS=$BASEDIR/build
158
159 # Check /tools symlink
160 if [ -h /tools ]; then
161 rm -f /tools
162 fi
163 if [ ! -a /tools ]; then
1b273e8f 164 ln -s $BASEDIR/build/tools /
df5e82b3
MT
165 fi
166 if [ ! -h /tools ]; then
1b273e8f 167 exiterror "Could not create /tools symbolic link."
df5e82b3
MT
168 fi
169
170 # Setup environment
171 set +h
172 LC_ALL=POSIX
1179dc27 173 MAKETUNING="-j6"
dd714b8a 174 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
df5e82b3
MT
175 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
176
177 # Make some extra directories
178 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
90d372c4 179 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
df5e82b3 180 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
90d372c4
MT
181 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
182
183 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
184 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
df5e82b3
MT
185
186 # Make all sources and proc available under lfs build
90d372c4 187 mount --bind /dev $BASEDIR/build/dev
857d9bf2
MT
188 mount --bind /dev/pts $BASEDIR/build/dev/pts
189 mount --bind /dev/shm $BASEDIR/build/dev/shm
190 mount --bind /proc $BASEDIR/build/proc
191 mount --bind /sys $BASEDIR/build/sys
df5e82b3
MT
192 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
193 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
194 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
195 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
196 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
197 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
198 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
199 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
200 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
201
119ee469 202 # This is a temporary hack!!!
6b8cff41
MT
203 if [ ! -f /tools/bin/hostname ]; then
204 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
205 fi
119ee469 206
df5e82b3
MT
207 # Run LFS static binary creation scripts one by one
208 export CCACHE_DIR=$BASEDIR/ccache
209 export CCACHE_HASHDIR=1
210
211 # Remove pre-install list of installed files in case user erase some files before rebuild
212 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
213}
214
df5e82b3
MT
215buildtoolchain() {
216 LOGFILE="$BASEDIR/log/_build.toolchain.log"
217 export LOGFILE
df5e82b3
MT
218 ORG_PATH=$PATH
219 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
220 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
221 lfsmake1 ccache
15679d9f
MT
222 lfsmake1 binutils PASS=1
223 lfsmake1 gcc PASS=1
df5e82b3 224 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
dd714b8a
MT
225 lfsmake1 linux-libc-header
226 lfsmake1 glibc
9b0ff0a0 227 lfsmake1 cleanup-toolchain PASS=1
df5e82b3
MT
228 lfsmake1 tcl
229 lfsmake1 expect
df5e82b3 230 lfsmake1 dejagnu
15679d9f
MT
231 lfsmake1 gcc PASS=2
232 lfsmake1 binutils PASS=2
dd714b8a
MT
233 lfsmake1 ncurses
234 lfsmake1 bash
df5e82b3 235 lfsmake1 bzip2
dd714b8a 236 lfsmake1 coreutils
df5e82b3
MT
237 lfsmake1 diffutils
238 lfsmake1 findutils
dd714b8a 239 lfsmake1 gawk
df5e82b3 240 lfsmake1 gettext
dd714b8a
MT
241 lfsmake1 grep
242 lfsmake1 gzip
243 lfsmake1 m4
244 lfsmake1 make
df5e82b3 245 lfsmake1 patch
dd714b8a
MT
246 lfsmake1 perl
247 lfsmake1 sed
df5e82b3
MT
248 lfsmake1 tar
249 lfsmake1 texinfo
df5e82b3 250 lfsmake1 util-linux
9b0ff0a0 251 lfsmake1 cleanup-toolchain PASS=2
df5e82b3
MT
252 export PATH=$ORG_PATH
253}
254
255buildbase() {
256 LOGFILE="$BASEDIR/log/_build.base.log"
257 export LOGFILE
df5e82b3 258 lfsmake2 stage2
9b0ff0a0 259 lfsmake2 linux-libc-header
df5e82b3
MT
260 lfsmake2 man-pages
261 lfsmake2 glibc
9b0ff0a0 262 lfsmake2 cleanup-toolchain PASS=3
df5e82b3
MT
263 lfsmake2 binutils
264 lfsmake2 gcc
9b0ff0a0 265 lfsmake2 berkeley
df5e82b3 266 lfsmake2 coreutils
df5e82b3 267 lfsmake2 iana-etc
df5e82b3
MT
268 lfsmake2 m4
269 lfsmake2 bison
9b0ff0a0
MT
270 lfsmake2 ncurses
271 lfsmake2 procps
df5e82b3 272 lfsmake2 sed
9b0ff0a0 273 lfsmake2 libtool
df5e82b3 274 lfsmake2 perl
9b0ff0a0
MT
275 lfsmake2 readline
276 lfsmake2 zlib
df5e82b3
MT
277 lfsmake2 autoconf
278 lfsmake2 automake
279 lfsmake2 bash
df5e82b3
MT
280 lfsmake2 bzip2
281 lfsmake2 diffutils
df5e82b3 282 lfsmake2 e2fsprogs
65998e0a 283 lfsmake2 ed
9b0ff0a0
MT
284 lfsmake2 file
285 lfsmake2 findutils
286 lfsmake2 flex
9b0ff0a0
MT
287 lfsmake2 gawk
288 lfsmake2 gettext
289 lfsmake2 grep
290 lfsmake2 groff
df5e82b3 291 lfsmake2 gzip
9b0ff0a0
MT
292 lfsmake2 inetutils
293 lfsmake2 iproute2
294 lfsmake2 kbd
295 lfsmake2 less
44254afd 296 lfsmake2 libaal
df5e82b3 297 lfsmake2 make
9b0ff0a0
MT
298 lfsmake2 man
299 lfsmake2 mktemp
df5e82b3 300 lfsmake2 modutils
65f8f30f 301 lfsmake2 mtd
65998e0a 302 lfsmake2 net-tools
df5e82b3 303 lfsmake2 patch
df5e82b3 304 lfsmake2 psmisc
44254afd 305 lfsmake2 reiser4progs
df5e82b3
MT
306 lfsmake2 shadow
307 lfsmake2 sysklogd
308 lfsmake2 sysvinit
309 lfsmake2 tar
90d372c4
MT
310 lfsmake2 texinfo
311 lfsmake2 udev
df5e82b3 312 lfsmake2 util-linux
90d372c4 313 lfsmake2 vim
44254afd 314 lfsmake2 grub
df5e82b3
MT
315}
316
15679d9f 317buildipfire() {
907cd036 318 LOGFILE="$BASEDIR/log/_build.ipfire.log"
df5e82b3 319 export LOGFILE
15679d9f
MT
320 ipfiremake configroot
321 ipfiremake dhcp
322 ipfiremake dhcpcd
323 ipfiremake libusb
324 ipfiremake libpcap
a10ae6cc 325 ipfiremake linux-atm
15679d9f
MT
326 ipfiremake ppp
327 ipfiremake rp-pppoe
328 ipfiremake unzip
3a1019f6 329 ipfiremake linux SMP=1
552b817b 330 ipfiremake ipp2p SMP=1
bb5774c8 331 ipfiremake r8169 SMP=1
dd001658 332 ipfiremake zaptel SMP=1
c3e36980 333 ipfiremake linux
552b817b 334 ipfiremake ipp2p
bb5774c8 335 ipfiremake r8169
119f6ad3 336 ipfiremake zaptel
c545beb1 337 ipfiremake pkg-config
ad9d4caf 338 ipfiremake cpio
ee78a5ef
MT
339 ipfiremake klibc
340 ipfiremake mkinitcpio
341 ipfiremake udev KLIBC=1
15679d9f
MT
342 ipfiremake expat
343 ipfiremake gdbm
344 ipfiremake gmp
c8ead4a5 345 ipfiremake pam
15679d9f 346 ipfiremake openssl
eac942d9 347 ipfiremake curl
15679d9f
MT
348 ipfiremake python
349 ipfiremake libnet
ddac6087 350 ipfiremake libjpeg
15679d9f
MT
351 ipfiremake libpng
352 ipfiremake libtiff
fd3e7da0 353 ipfiremake libart
9594506f 354 ipfiremake freetype
15679d9f
MT
355 ipfiremake gd
356 ipfiremake popt
411afd1f 357 ipfiremake pcre
15679d9f
MT
358 ipfiremake slang
359 ipfiremake newt
fd3e7da0 360 ipfiremake libcap
15679d9f 361 ipfiremake pciutils
51f3b7f5 362 ipfiremake usbutils
15679d9f 363 ipfiremake libxml2
c6c9630e 364 ipfiremake libxslt
6b8cff41 365 ipfiremake BerkeleyDB
15679d9f 366 ipfiremake mysql
411afd1f 367 ipfiremake cyrus-sasl
15679d9f
MT
368 ipfiremake openldap
369 ipfiremake apache2
370 ipfiremake php
a10ae6cc 371 ipfiremake apache2 PASS=C
15679d9f
MT
372 ipfiremake arping
373 ipfiremake beep
374 ipfiremake bind
15679d9f
MT
375 ipfiremake cdrtools
376 ipfiremake dnsmasq
377 ipfiremake dosfstools
444973a4 378 ipfiremake squashfstools
72d80898 379 ipfiremake reiserfsprogs
93afd047 380 ipfiremake sysfsutils
8e055e65 381 ipfiremake fuse
d02350a2 382 ipfiremake ntfs-3g
15679d9f
MT
383 ipfiremake ethtool
384 ipfiremake ez-ipupdate
385 ipfiremake fcron
e3670217 386 ipfiremake perl-GD
330345c2 387 ipfiremake GD-Graph
786f2c8a 388 ipfiremake GD-TextUtil
15679d9f
MT
389 ipfiremake gnupg
390 ipfiremake hdparm
7861f575 391 ipfiremake mtools
15679d9f 392 ipfiremake initscripts
406f019f 393 ipfiremake whatmask
15679d9f 394 ipfiremake iptables
490256d5 395 ipfiremake libupnp
552b817b 396 ipfiremake ipp2p IPT=1
81a7e7c8 397 ipfiremake moblock
490256d5 398 ipfiremake linux-igd
15679d9f
MT
399 ipfiremake ipac-ng
400 ipfiremake ipaddr
15679d9f 401 ipfiremake iptstate
fd3e7da0 402 ipfiremake iputils
15679d9f 403 ipfiremake l7-protocols
8bba2965 404 ipfiremake mISDN
93afd047 405 ipfiremake hwdata
72d80898 406 ipfiremake kudzu
15679d9f
MT
407 ipfiremake logrotate
408 ipfiremake logwatch
15679d9f 409 ipfiremake misc-progs
15679d9f 410 ipfiremake nano
15679d9f
MT
411 ipfiremake nasm
412 ipfiremake URI
413 ipfiremake HTML-Tagset
414 ipfiremake HTML-Parser
415 ipfiremake Compress-Zlib
416 ipfiremake Digest
417 ipfiremake Digest-SHA1
418 ipfiremake Digest-HMAC
419 ipfiremake libwww-perl
420 ipfiremake Net-DNS
421 ipfiremake Net-IPv4Addr
422 ipfiremake Net_SSLeay
423 ipfiremake IO-Stringy
424 ipfiremake Unix-Syslog
425 ipfiremake Mail-Tools
426 ipfiremake MIME-Tools
427 ipfiremake Net-Server
428 ipfiremake Convert-TNEF
429 ipfiremake Convert-UUlib
430 ipfiremake Archive-Tar
431 ipfiremake Archive-Zip
432 ipfiremake Text-Tabs+Wrap
433 ipfiremake Locale-Country
93afd047 434 ipfiremake XML-Parser
c5568d64 435 ipfiremake glib
15679d9f
MT
436 ipfiremake GeoIP
437 ipfiremake fwhits
438 ipfiremake noip_updater
439 ipfiremake ntp
15679d9f
MT
440 ipfiremake openssh
441 ipfiremake openswan
15679d9f
MT
442 ipfiremake rrdtool
443 ipfiremake setserial
444 ipfiremake setup
445 ipfiremake snort
8a5604bf 446 ipfiremake oinkmaster
15679d9f
MT
447 ipfiremake squid
448 ipfiremake squid-graph
449 ipfiremake squidguard
069ae085 450 ipfiremake calamaris
6f00de0d 451 ipfiremake tcpdump
15679d9f
MT
452 ipfiremake traceroute
453 ipfiremake vlan
454 ipfiremake wireless
455 ipfiremake libsafe
15679d9f 456 ipfiremake pakfire
15679d9f 457 ipfiremake java
15679d9f
MT
458 ipfiremake spandsp
459 ipfiremake lzo
460 ipfiremake openvpn
15679d9f 461 ipfiremake pammysql
15679d9f 462 ipfiremake cups
fccb3371
MT
463 ipfiremake ghostscript
464 ipfiremake foomatic
15679d9f
MT
465 ipfiremake samba
466 ipfiremake sudo
467 ipfiremake mc
468 ipfiremake wget
15679d9f
MT
469 ipfiremake bridge-utils
470 ipfiremake screen
471 ipfiremake hddtemp
472 ipfiremake smartmontools
473 ipfiremake htop
15679d9f 474 ipfiremake postfix
15679d9f
MT
475 ipfiremake fetchmail
476 ipfiremake cyrusimap
477 ipfiremake webcyradm
478 ipfiremake mailx
479 ipfiremake clamav
15679d9f 480 ipfiremake spamassassin
fd3e7da0 481 ipfiremake amavisd
0708852c 482 ipfiremake alsa
15679d9f 483 ipfiremake mpg123
a28fdc01 484 ipfiremake mpfire
6c98857b 485 ipfiremake guardian
67081922 486 ipfiremake libid3tag
15679d9f
MT
487 ipfiremake libmad
488 ipfiremake libogg
489 ipfiremake libvorbis
490 ipfiremake lame
15679d9f 491 ipfiremake sox
a6931e7e
MT
492 ipfiremake libshout
493 ipfiremake icecast
909d16ee 494 ipfiremake icegenerator
71043200 495 ipfiremake mpd
f86b0cc3 496 ipfiremake mpc
24fd09e4
MT
497 ipfiremake xvid
498 ipfiremake libmpeg2
499 #ipfiremake ffmpeg
500 ipfiremake videolan
0708852c
MT
501 ipfiremake libpri
502 ipfiremake stund
0708852c
MT
503 ipfiremake asterisk
504 ipfiremake backup
15679d9f 505 ipfiremake gnump3d
eac942d9 506 ipfiremake libsigc++
15679d9f
MT
507 ipfiremake applejuice
508 ipfiremake ocaml
509 ipfiremake mldonkey
eac942d9
MT
510 ipfiremake libtorrent
511 ipfiremake rtorrent
06209efc 512 ipfiremake ipfireseeder
15679d9f
MT
513 ipfiremake rsync
514 ipfiremake tcpwrapper
515 ipfiremake portmap
516 ipfiremake nfs
517 ipfiremake nmap
518 ipfiremake mbmon
519 ipfiremake iftop
520 ipfiremake ncftp
521 ipfiremake cftp
522 ipfiremake etherwake
523 ipfiremake ethereal
524 ipfiremake tftp-hpa
06da1292 525 ipfiremake bwm-ng
1a8688ba
MT
526 ipfiremake tripwire
527 ipfiremake sysstat
a08c3a2e 528 ipfiremake vsftpd
51f3b7f5 529 ipfiremake which
186e3d2c 530 ipfiremake lsof
df5e82b3
MT
531}
532
533buildinstaller() {
534 # Run installer scripts one by one
535 LOGFILE="$BASEDIR/log/_build.installer.log"
536 export LOGFILE
0afc6d83 537 ipfiremake syslinux
4dc82852
MT
538 ipfiremake as86
539 ipfiremake mbr
fd0763dc 540 ipfiremake memtest
bc9f0c12
MT
541 installmake linux-libc-header
542 installmake binutils
543 ipfiremake uClibc PASS=1
544 ipfiremake gcc INST=1
545 installmake uClibc PASS=2
546 installmake gcc INST=2
547 installmake uClibc PASS=3
df5e82b3 548 installmake busybox
c66941dd 549 installmake udev
33634aa8
MT
550 installmake slang
551 installmake newt
72d80898 552 installmake gettext
33634aa8
MT
553 installmake kbd
554 installmake popt
33634aa8 555 installmake sysvinit
df5e82b3 556 installmake misc-progs
44254afd
MT
557 installmake libaal
558 installmake reiser4progs
89069053 559 installmake reiserfsprogs
a6316ce4 560 installmake sysfsutils
df5e82b3 561 installmake util-linux
df5e82b3 562 installmake pciutils
c5568d64 563 installmake zlib
65f8f30f 564 installmake mtd
c78a77eb 565 installmake wget
93afd047 566 installmake hwdata
fcb5057d 567 installmake kudzu
df5e82b3 568 installmake installer
df5e82b3 569 installmake initrd
df5e82b3
MT
570}
571
572buildpackages() {
573 LOGFILE="$BASEDIR/log/_build.packages.log"
574 export LOGFILE
575 echo "... see detailed log in _build.*.log files" >> $LOGFILE
0fbb45e9 576
edd536b6 577 installmake strip
df5e82b3
MT
578
579 # Generating list of packages used
0fbb45e9 580 echo -n "Generating packages list from logs" | tee -a $LOGFILE
df5e82b3
MT
581 rm -f $BASEDIR/doc/packages-list
582 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
583 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
7471f6ab 584 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
df5e82b3
MT
585 fi
586 done
7471f6ab 587 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
4fe9acb2 588 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
df5e82b3
MT
589 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
590 rm -f $BASEDIR/doc/packages-list
c9673262 591 # packages-list.txt is ready to be displayed for wiki page
0fbb45e9 592 beautify message DONE
df5e82b3 593
9607771a 594 # Create images for install
74dbbc36
MT
595 ipfiremake cdrom ED=full
596
4dc82852 597 # Check if there is a loop device for building in virtual environments
eedc26d9 598 if [ -e /dev/loop/0 ] || [ -e /dev/loop0 ]; then
4dc82852
MT
599 ipfiremake usb-stick
600 fi
33634aa8 601 ipfiremake pxe
4dc82852 602 mv $LFS/install/images/{*.iso,*.tgz,*.img.gz} $BASEDIR >> $LOGFILE 2>&1
c9673262 603
0d909a4a 604 ipfirepackages
e67a57fe
MT
605
606 # Cleanup
607 stdumount
608 rm -rf $BASEDIR/build/tmp/*
609
610 # Generating total list of files
0d909a4a 611 echo -n "Generating files list from logs" | tee -a $LOGFILE
e67a57fe
MT
612 rm -f $BASEDIR/log/FILES
613 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
614 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
615 echo "##" >>$BASEDIR/log/FILES
616 echo "## `basename $i`" >>$BASEDIR/log/FILES
617 echo "##" >>$BASEDIR/log/FILES
618 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
619 fi
620 done
0d909a4a 621 beautify message DONE
e67a57fe
MT
622
623 cd $PWD
e67a57fe
MT
624}
625
626ipfirepackages() {
a5997a4c 627 ipfiremake core-updates
fe7fe395
MT
628 for i in $(ls -1 $BASEDIR/config/rootfiles/packages); do
629 [ -e $BASEDIR/lfs/$i ] && ipfiredist $i
630 done
78331e30 631 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
5c8cfc99 632 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
483f59cd 633 rm -rf $BASEDIR/build/install/packages/*
df5e82b3
MT
634}
635
636# See what we're supposed to do
637case "$1" in
638build)
9729e787 639 clear
df5e82b3 640 BUILDMACHINE=`uname -m`
712d859c 641 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
df5e82b3 642 #only restore on a clean disk
9b0ff0a0 643 if [ ! -f log/cleanup-toolchain-2-tools ]; then
df5e82b3 644 if [ ! -n "$PACKAGE" ]; then
15679d9f 645 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
df5e82b3
MT
646 prepareenv
647 buildtoolchain
648 else
649 PACKAGENAME=${PACKAGE%.tar.gz}
15679d9f 650 beautify build_stage "Packaged toolchain compilation"
df5e82b3
MT
651 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
652 tar zxf $PACKAGE
653 prepareenv
654 else
655 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
656 fi
657 fi
658 else
9729e787
MT
659 echo -n "Using installed toolchain" | tee -a $LOGFILE
660 beautify message SKIP
df5e82b3
MT
661 prepareenv
662 fi
5cfe86e6 663
7ab7a9b4 664 beautify build_start
0b59f25c 665 beautify build_stage "Building LFS"
df5e82b3 666 buildbase
15679d9f 667
0b59f25c 668 beautify build_stage "Building IPFire"
15679d9f 669 buildipfire
5cfe86e6
HS
670
671 # Setzen des IPFire Builds
8af06406 672 if [ "$FIREBUILD" ]; then
e57bc1fd 673 echo "$FIREBUILD" > $BASEDIR/build/var/ipfire/firebuild
5cfe86e6 674 else
e57bc1fd 675 echo "_(OvO)_" > $BASEDIR/build/var/ipfire/firebuild
5cfe86e6
HS
676 fi
677
0b59f25c 678 beautify build_stage "Building installer"
df5e82b3 679 buildinstaller
15679d9f 680
0b59f25c 681 beautify build_stage "Building packages"
df5e82b3 682 buildpackages
7ab7a9b4 683 beautify build_end
df5e82b3
MT
684 ;;
685shell)
686 # enter a shell inside LFS chroot
687 # may be used to changed kernel settings
688 prepareenv
689 entershell
690 ;;
691changelog)
d1dd6669 692 echo -n "Loading new Changelog from SVN: "
223ad6a4 693 svn log http://svn.ipfire.org/svn/ipfire > doc/ChangeLog
a50d04ab 694 beautify message DONE
df5e82b3 695 ;;
df5e82b3 696clean)
a50d04ab 697 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
df5e82b3
MT
698 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
699 $LOSETUP -d $i 2>/dev/null
700 done
701 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
702 umount $i
703 done
704 stdumount
705 for i in `seq 0 7`; do
706 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
707 umount /dev/loop${i} 2>/dev/null;
708 losetup -d /dev/loop${i} 2>/dev/null;
709 fi;
710 done
711 rm -rf $BASEDIR/build
712 rm -rf $BASEDIR/cdrom
f9315063 713 rm -rf $BASEDIR/packages
df5e82b3 714 rm -rf $BASEDIR/log
df5e82b3
MT
715 if [ -h /tools ]; then
716 rm -f /tools
717 fi
a50d04ab 718 beautify message DONE
df5e82b3 719 ;;
c3db995c 720downloadsrc)
df5e82b3
MT
721 if [ ! -d $BASEDIR/cache ]; then
722 mkdir $BASEDIR/cache
723 fi
724 mkdir -p $BASEDIR/log
857d9bf2 725 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
df5e82b3
MT
726 FINISHED=0
727 cd $BASEDIR/lfs
728 for c in `seq $MAX_RETRIES`; do
729 if (( FINISHED==1 )); then
730 break
731 fi
732 FINISHED=1
733 cd $BASEDIR/lfs
734 for i in *; do
735 if [ -f "$i" -a "$i" != "Config" ]; then
e22c7973 736 echo -ne "Loading $i"
df5e82b3
MT
737 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
738 if [ $? -ne 0 ]; then
e22c7973 739 beautify message FAIL
df5e82b3
MT
740 FINISHED=0
741 else
742 if [ $c -eq 1 ]; then
e22c7973 743 beautify message DONE
df5e82b3
MT
744 fi
745 fi
746 fi
747 done
748 done
e22c7973 749 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
df5e82b3
MT
750 ERROR=0
751 for i in *; do
752 if [ -f "$i" -a "$i" != "Config" ]; then
753 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
754 if [ $? -ne 0 ]; then
e22c7973
MT
755 echo -ne "MD5 difference in lfs/$i"
756 beautify message FAIL
df5e82b3
MT
757 ERROR=1
758 fi
759 fi
760 done
761 if [ $ERROR -eq 0 ]; then
e22c7973
MT
762 echo -ne "${BOLD}all files md5sum match${NORMAL}"
763 beautify message DONE
764 else
765 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
766 beautify message FAIL
df5e82b3 767 fi
e22c7973 768 cd - >/dev/null 2>&1
df5e82b3 769 ;;
df5e82b3 770toolchain)
9729e787 771 clear
df5e82b3 772 prepareenv
15679d9f 773 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
df5e82b3
MT
774 buildtoolchain
775 BUILDMACHINE=`uname -m`
776 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
712d859c
MT
777 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
778 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
df5e82b3
MT
779 build/{bin,etc,usr/bin,usr/local} \
780 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
781 log >> $LOGFILE
712d859c
MT
782 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
783 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
df5e82b3
MT
784 stdumount
785 ;;
786gettoolchain)
787 BUILDMACHINE=`uname -m`
788 # arbitrary name to be updated in case of new toolchain package upload
c6cb9d25 789 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
712d859c 790 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
5bd13f01 791 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
712d859c
MT
792 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
793 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
794 cd $BASEDIR/cache/toolchains
5bd13f01 795 wget $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
712d859c
MT
796 if [ $? -ne 0 ]; then
797 echo "`date -u '+%b %e %T'`: error downloading toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
40a4ea4c 798 else
712d859c
MT
799 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
800 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
801 else
802 exiterror "$PACKAGE.md5 did not match, check downloaded package"
803 fi
40a4ea4c 804 fi
712d859c
MT
805 else
806 echo "Toolchain is already downloaded. Exiting..."
df5e82b3
MT
807 fi
808 ;;
15679d9f 809othersrc)
ce56e927 810 prepareenv
15679d9f 811 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
ce56e927
MT
812 chroot $LFS /tools/bin/env -i HOME=/root \
813 TERM=$TERM PS1='\u:\w\$ ' \
814 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
815 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
816 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
817 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
15679d9f
MT
818 if [ $? -eq "0" ]; then
819 beautify message DONE
820 else
821 beautify message FAIL
822 fi
ce56e927
MT
823 stdumount
824 ;;
c6cb9d25
MT
825svn)
826 case "$2" in
827 update|up)
cc0e56be 828 # clear
15679d9f 829 echo -ne "Loading the latest source files...\n"
7471f6ab
MT
830 if [ $3 ]; then
831 svn update -r $3 | tee -a $PWD/log/_build.svn.update.log
832 else
833 svn update | tee -a $PWD/log/_build.svn.update.log
834 fi
15679d9f
MT
835 if [ $? -eq "0" ]; then
836 beautify message DONE
c6cb9d25 837 else
15679d9f 838 beautify message FAIL
c6cb9d25
MT
839 exit 1
840 fi
15679d9f 841 echo -ne "Writing the svn-info to a file"
c6cb9d25 842 svn info > $PWD/svn_status
15679d9f
MT
843 if [ $? -eq "0" ]; then
844 beautify message DONE
c6cb9d25 845 else
15679d9f 846 beautify message FAIL
c6cb9d25
MT
847 exit 1
848 fi
712d859c 849 chmod 755 $0
cc0e56be 850 exit 0
c6cb9d25
MT
851 ;;
852 commit|ci)
853 clear
6b8cff41
MT
854 if [ -f /usr/bin/mcedit ]; then
855 export EDITOR=/usr/bin/mcedit
73d9a908
MT
856 fi
857 if [ -f /usr/bin/nano ]; then
858 export EDITOR=/usr/bin/nano
6b8cff41
MT
859 fi
860 echo -ne "Selecting editor $EDITOR..."
861 beautify message DONE
d79b46cb 862 if [ -e /sbin/yast ]; then
028698e8
MT
863 if [ "`echo $SVN_REVISION | cut -c 3`" -eq "0" ]; then
864 $0 changelog
865 fi
d79b46cb 866 fi
8a5f0f44 867 update_langs
15679d9f 868 svn commit
c6cb9d25 869 $0 svn up
1065bfea
MT
870 if [ -n "$FTP_CACHE_URL" ]; then
871 $0 uploadsrc
872 fi
c6cb9d25
MT
873 ;;
874 dist)
7471f6ab
MT
875 if [ $3 ]; then
876 SVN_REVISION=$3
877 fi
878 if [ -f ipfire-source-r$SVN_REVISION.tar.gz ]; then
879 echo -ne "REV $SVN_REVISION: SKIPPED!\n"
880 exit 0
881 fi
882 echo -en "REV $SVN_REVISION: Downloading..."
223ad6a4
MT
883 svn export http://svn.ipfire.org/svn/ipfire/trunk ipfire-source/ --force > /dev/null
884 svn log http://svn.ipfire.org/svn/ipfire/trunk -r 1:$SVN_REVISION > ipfire-source/Changelog
885 #svn info http://svn.ipfire.org/svn/ipfire/trunk -r $SVN_REVISION > ipfire-source/svn_status
15679d9f
MT
886 evaluate 1
887
7471f6ab
MT
888 echo -en "REV $SVN_REVISION: Compressing files..."
889 if [ -e ipfire-source/trunk/make.sh ]; then
890 chmod 755 ipfire-source/trunk/make.sh
891 fi
9dc02b38 892 tar cfz ipfire-source-r$SVN_REVISION.tar.gz ipfire-source
15679d9f 893 evaluate 1
7471f6ab 894 echo -en "REV $SVN_REVISION: Cleaning up..."
c6cb9d25 895 rm ipfire-source/ -r
15679d9f 896 evaluate 1
7471f6ab 897 ;;
028698e8 898 diff|di)
1a8688ba 899 update_langs
15679d9f 900 echo -ne "Make a local diff to last svn revision"
c6cb9d25 901 svn diff > ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff
15679d9f 902 evaluate 1
c6cb9d25 903 echo "Diff was successfully saved to ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff"
bf7c473f 904 svn status
c6cb9d25
MT
905 ;;
906 esac
f9315063 907 ;;
15679d9f
MT
908uploadsrc)
909 PWD=`pwd`
910 cd $BASEDIR/cache/
911 echo -e "Uploading cache to ftp server:"
6fb8ec08 912 ncftpls -u $FTP_CACHE_USER -p $FTP_CACHE_PASS ftp://$FTP_CACHE_URL$FTP_CACHE_PATH/ > /tmp/ftplist
15679d9f 913 for i in *; do
f59e1e88 914 if [ "$i" == "toolchains" ]; then continue; fi
6fb8ec08 915 grep -q $i /tmp/ftplist
0eab8e84 916 if [ "$?" -ne "0" ]; then
15679d9f 917 echo -ne "$i"
71e32384 918 ncftpput -u $FTP_CACHE_USER -p $FTP_CACHE_PASS $FTP_CACHE_URL $FTP_CACHE_PATH/ $i
6fb8ec08 919 if [ "$?" -ne "0" ]; then
15679d9f 920 beautify message FAIL
0eab8e84
MT
921 fi
922 fi
923 done
6fb8ec08 924 rm -f /tmp/ftplist
15679d9f
MT
925 cd $PWD
926 exit 0
0eab8e84 927 ;;
cc0e56be 928upload)
b2c64f8c
MT
929 FTP_ISO_PORT=`echo "$FTP_ISO_URL" | awk -F: '{ print $2 }'`
930 FTP_ISO_URL=`echo "$FTP_ISO_URL" | awk -F: '{ print $1 }'`
931 if [ -z $FTP_ISO_PORT ]; then
932 FTP_ISO_PORT=21
933 fi
934 cat <<EOF > .ftp-commands
de2c999d 935mkdir -p $FTP_ISO_PATH$SVN_REVISION
b2c64f8c 936mkdir -p $FTP_ISO_PATH$SVN_REVISION/paks
9dc02b38
MT
937quit
938EOF
b2c64f8c
MT
939 ncftp -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL < .ftp-commands
940 rm -f .ftp-commands
941
942 case "$2" in
943 iso)
944 echo -e "Uploading the iso to $FTP_ISO_PATH/$SVN_REVISION."
945
8f55c54e 946 md5sum ipfire-$VERSION.$MACHINE-full.iso > ipfire-$VERSION.$MACHINE-full.iso.md5
dff9df9d
MT
947 for i in svn_status ipfire-source-r$SVN_REVISION.tar.gz ipfire-$VERSION.$MACHINE-full.iso ipfire-$VERSION.$MACHINE-full.iso.md5 ipfire-$VERSION.$MACHINE-devel.iso ipfire-$VERSION.$MACHINE-devel.iso.md5; do
948 if [ -e "$i" ]; then
b2c64f8c
MT
949 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ $i
950 if [ "$?" -eq "0" ]; then
951 echo "The file with name $i was successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
952 else
953 echo "There was an error while uploading the file $i to the ftp server."
954 exit 1
955 fi
dff9df9d 956 fi
b2c64f8c 957 done
a4c9c660 958 rm -f ipfire-$VERSION.$MACHINE-full.iso.md5
6aae8d61 959 if [ "$3" = "--with-sources-cd" ]; then
b2c64f8c 960 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH/$SVN_REVISION/ ipfire-sources-cd-$VERSION.$MACHINE.iso
6aae8d61 961 fi
cc0e56be
MT
962 ;;
963 paks)
b2c64f8c 964 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/paks packages/*
cc0e56be 965 if [ "$?" -eq "0" ]; then
822c5bd0 966 echo -e "The packages were successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
cc0e56be
MT
967 else
968 echo -e "There was an error while uploading the packages to the ftp server."
712d859c 969 exit 1
cc0e56be
MT
970 fi
971 ;;
972 esac
0d0521b6 973 ;;
cc0e56be 974batch)
c8582074 975 if [ "$2" = "--background" ]; then
15679d9f
MT
976 batch_script
977 exit $?
978 fi
27ac55bf 979 if [ `screen -ls | grep -q ipfire` ]; then
712d859c
MT
980 echo "Build is already running, sorry!"
981 exit 1
982 else
27ac55bf
MT
983 if [ "$2" = "--rebuild" ]; then
984 export IPFIRE_REBUILD=1
985 echo "REBUILD!"
986 else
987 export IPFIRE_REBUILD=0
988 fi
15679d9f
MT
989 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
990 screen -dmS ipfire $0 batch --background
991 evaluate 1
712d859c
MT
992 exit 0
993 fi
cc0e56be 994 ;;
028698e8 995watch)
15679d9f 996 watch_screen
028698e8 997 ;;
33634aa8
MT
998pxe)
999 case "$2" in
1000 start)
1001 start_tftpd
1002 ;;
1003 stop)
1004 stop_tftpd
1005 ;;
a50d04ab 1006 reload|restart)
33634aa8
MT
1007 reload_tftpd
1008 ;;
1009 esac
1010 exit 0
1011 ;;
bf7c473f
MT
1012lang)
1013 update_langs
1014 ;;
6b8cff41 1015"")
24a4a744
MT
1016 clear
1017 svn info
c3db995c 1018 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "SVN: Commit" "SVN: Update" "SVN: Status" "SVN: Diff" "LOG: Tail" "Help"
24a4a744
MT
1019 do
1020 case $name in
c3db995c
MT
1021 "IPFIRE: Downloadsrc")
1022 $0 downloadsrc
c6cb9d25
MT
1023 ;;
1024 "IPFIRE: Build (silent)")
1025 $0 build-silent
1026 ;;
1027 "IPFIRE: Watch Build")
028698e8 1028 $0 watch
c6cb9d25 1029 ;;
712d859c
MT
1030 "IPFIRE: Batch")
1031 $0 batch
1032 ;;
c6cb9d25
MT
1033 "IPFIRE: Clean")
1034 $0 clean
1035 ;;
c6cb9d25
MT
1036 "SVN: Update")
1037 $0 svn update
1038 ;;
c6cb9d25 1039 "Help")
a50d04ab 1040 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
c6cb9d25
MT
1041 cat doc/make.sh-usage
1042 ;;
712d859c
MT
1043 "LOG: Tail")
1044 tail -f log/_*
1045 ;;
c6cb9d25
MT
1046 "Exit")
1047 break
1048 ;;
24a4a744
MT
1049 esac
1050 done
df5e82b3 1051 ;;
a50d04ab
MT
1052config)
1053 make_config
1054 ;;
6b8cff41 1055*)
a50d04ab 1056 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
6b8cff41
MT
1057 cat doc/make.sh-usage
1058 ;;
3ea75603 1059esac